/*
  File: PresentValue.h
  Authors: Eric Bergerson
  Modification History:

  Changed parent class to Object.
    2/13/91 - Eric Bergerson

  Copyright (c) 1991 Objective Technologies, Inc.
  All Rights Reserved.
*/

#import <objc/Object.h>

@interface PresentValue:Object
{
    id	rate;
    id	periods;
    id	futureValue;
    id	processor;

    id  from;
    id  to;
    id  graph;
    id  gprocessor;

    id  monitor;
    id  monitorSV;

    id  initProcessor;
    BOOL monitorEnabled;
}

- init;
- appDidInit: sender;

- setRate:anObject;
- setPeriods:anObject;
- setFutureValue:anObject;
- setProcessor: anObject;

- setFrom: anObject;
- setTo: anObject;
- setGprocessor: anObject;

- presentValue:sender;
- graph:sender;
- statusDidChange: mathObj to:(int) status;
- kernelDidMsg: (const char *) aMsg from: aMathPipe type: msgType;

- reInitKernel: sender;

- flipMonitorEnabled: sender;

/* Math Access delegate method */
- (const char *) resultErrorText;

@end
