/*
  File: UpdateSlider.m
  Authors: Eric Bergerson
  Modification History:

  Copyright (c) 1990 Objective Technologies, Inc.
  All Rights Reserved.
*/

#import <appkit/appkit.h>
#import "UpdateSlider.h"
#import "UpdateSliderCell.h"
static BOOL cellCreated = NO;

@implementation UpdateSlider

+ newFrame: (const NXRect *)frameRect;
{
  if(!cellCreated){
    cellCreated = YES;
    [UpdateSlider setCellClass:[UpdateSliderCell class]];
  }

  self = [super newFrame: frameRect];
  [self setContinuous: YES];
  return self;
}

- setMonitor:anObject
{
    monitor = anObject;
    return self;
}

- performMove:sender
{
  [self setDoubleValue: [sender doubleValue]];

  if([self target] != nil)
    [self sendAction: [self action] to: [self target]];

  return self;
}

- controlChange: sender
{
  if(monitor && [monitor respondsTo:@selector(setDoubleValue:)])
    [monitor setDoubleValue: [self doubleValue]];

  return self;
}
@end
