/*
  File: UpdateSliderCell.m
  Authors: Eric Bergerson
  Modification History:


  Copyright (c) 1990 Objective Technologies, Inc.
  All Rights Reserved.
*/

#import <appkit/appkit.h>
#import "UpdateSliderCell.h"
#import "UpdateSlider.h"

@implementation UpdateSliderCell

- (BOOL)trackMouse:(NXEvent *)theEvent
        inRect:(const NXRect *)cellFrame
        ofView:controlView
{
  int eventMask;
  int ret = NO;
  NXPoint p1, p2;
  id controlWindow;

  if(controlView == nil || 
     [self isEnabled] == NO || 
     theEvent->type == NX_MOUSEUP)
    return YES;

  p1 = theEvent->location;
  [controlView convertPoint:&p1 fromView:nil];

  if(theEvent->type == NX_MOUSEDOWN){
    [self startTrackingAt:&p1 inView: controlView];
    [controlView controlChange: self];
  }

  controlWindow = [controlView window];
  eventMask = [controlWindow eventMask];
  [controlWindow addToEventMask:NX_MOUSEDRAGGEDMASK|NX_MOUSEUPMASK];

  while(!ret){
    NXPing();
    theEvent = [NXApp getNextEvent:NX_MOUSEDRAGGEDMASK|NX_MOUSEUPMASK];
    if(theEvent->type == NX_MOUSEUP){
      [self stopTracking: &p1 at:&p1 
            inView:controlView mouseIsUp: YES];
      [controlView performMove: self];
      ret = YES;
    }else{
      p2 = theEvent->location;
      [controlView convertPoint:&p2 fromView:nil];

      if(p2.x != p1.x || p2.y != p1.y){
	[self continueTracking: &p1 at:&p2 inView:controlView];
	[controlView controlChange: self];
	p1 = p2;
      }    
    }
  }

  [controlWindow setEventMask:eventMask];
  return ret;
}

@end

    
  
